clc, clear


P   = 50;
n   = 4;

g   = 9.80665;
l   = 1;
m   = 1;
k1  = 80;
k2  = 80;
d1  = .8;
d2  = .8;
phi3    = pi/2;
phi10   = 0;
phi20   = pi/2;

O = zeros(2);
M = [ 4*m*l^2/3 , m*l^2/2*cos(phi10-phi20) ;
      m*l^2/2*cos(phi10-phi20) , m*l^2/3 ];
D = [d1+d2,-d2;-d2,d2];
f = 20-10*sin(2*pi*(1:P)/P);
for i = 1:P
    K(:,:,i) = [k1+k2-3*m*l^2*g/2*sin(phi10)-f(i)*l*cos(phi10-phi3) , -k2 ;
                -k2 , k2-m*l^2*g/2*sin(phi20)-f(i)*l*cos(phi20-phi3) ];
    a(:,:,i) = [O,M;M,D]\[-M,O;O,K(:,:,i)];
    c(:,:,i) = eye(n);
end

%plot(f)
figure(1), clf, hold on
for i = 1:P
    plot((i-1)*2/P,imag(eig(a(:,:,i))),'o')
end
set(gca,'ylim',[15.5,16.9])
figure(2), clf, hold on
for i = 1:P
    plot((i-1)*2/P,imag(eig(a(:,:,i))),'o')
end
set(gca,'ylim',[2,6])