function [sysh, xhini, t] = pltv_ident2(y, P, n, opt)
t = 0;
[T, p] = size(y); pp = p * P; Tp = floor(T / P); 
if ~exist('i', 'var'), i = 1; end
yp = reshape(vec(y(i:(Tp - 1) * P + i - 1, :)'), ...
             pp, Tp - 1); 
if exist('opt')
  L = ceil((n + 1) / pp);
else
  L = ceil((Tp + 1) / (pp + 1));
end
H = blkhank(yp, L);
tic, [U, S, V] = svd(H, 'econ'); t = t + toc;
if size(V, 1) < n, error('Not enough data.'), end
s = diag(S); sqrt_s = sqrt(s(1:n))';
O =  sqrt_s(ones(size(U, 1), 1), :) .* U(:, 1:n);
C = (sqrt_s(ones(size(V, 1), 1), :) .* V(:, 1:n))'; 
xhini = C(:, 1); psi = O(1:pp, :); 
%phi = O(1:end - pp, :) \ O((pp + 1):end, :);
phi = C(:, 2:end) / C(:, 1:end - 1);
for i = 1:P
  a(:, :, i) = eye(n); 
  c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
end
a(:, :, P) = phi; 
sysh = struct('a', a, 'c', c); 
