function [sysh, xhini, t] = pltv_ident3(y, P, n, opt)
t = 0;
[T, p] = size(y); pp = p * P; Tp = floor(T / P); 
yp = shiftdim(reshape(vec(y(1:(Tp * P), :)'), ...
              p, P, Tp), 2);
if exist('opt')
  L = n + 1;
else
  L = floor((Tp + 1) / (pp + 1) * pp);
end
H = blkhank(shiftdim(yp, 1), L); 
tic, [U, S, V] = svd(H, 'econ'); t = t + toc;
s = diag(S); sqrt_s = sqrt(s(1:n))';
O =  sqrt_s(ones(size(U, 1), 1), :) .* U(:, 1:n);
C = (sqrt_s(ones(size(V, 1), 1), :) .* V(:, 1:n))'; 
xhini = O(1, :)'; psi = C(:, 1:pp)'; 
phi   = (O(1:end - 1, :) \ O(2:end, :))';
for i = 1:P
  a(:, :, i) = eye(n); 
  c(:, :, i) = psi((i - 1) * p + 1: i * p, :); 
end
a(:, :, P) = phi;
sysh = struct('a', a, 'c', c); 
