function sys = pltv_canon(sysh)
n = 2; nn = n * n; P = 3;
I = eye(n); Z = zeros(nn); 
ac = [0 1; 1 1]; Ac = kron(I, ac);
cc = [1 0]; Cc = kron(I, cc);
A = [Ac -kron(sysh.a(:, :, 1)', I) Z; 
     Z Ac -kron(sysh.a(:, :, 2)', I)
     -kron(sysh.a(:, :, 3)', I) Z Ac];
A(n:n:end, :) = [];
V = [A; blkdiag(Cc, Cc, Cc)] \ [zeros(n * P, 1); sysh.c(:)];
for i = 1:P, v(:, :, i) = reshape(V((i - 1) * nn + 1: i * nn) , n, n); end
sys = pltv_ss2ss(sysh, v);