function [sysh, xhini, t] = pltv_ident1(y, P, n, opt)
t = 0;
for i = 1:P + 1 
  if i < P + 1
    [T, p] = size(y); pp = p * P; Tp = floor(T / P); 
    if ~exist('i', 'var'), i = 1; end
    yp = reshape(vec(y(i:(Tp - 1) * P + i - 1, :)'), ...
                 pp, Tp - 1); 
    if exist('opt')
      L = ceil((n + 1) / pp);
    else
      L = ceil((Tp + 1) / (pp + 1));
    end
    H = blkhank(yp, L);
    tic, [U, S, V] = svd(H, 'econ'); t = t + toc;
    if size(V, 1) < n, error('Not enough data.'), end
    s = diag(S); sqrt_s = sqrt(s(1:n))';
    O =  sqrt_s(ones(size(U, 1), 1), :) .* U(:, 1:n);
    C = (sqrt_s(ones(size(V, 1), 1), :) .* V(:, 1:n))'; 
    xhini = C(:, 1); psi = O(1:pp, :); 
    %phi = O(1:end - pp, :) \ O((pp + 1):end, :);
    phi = C(:, 2:end) / C(:, 1:end - 1);
    Xh{i} = C;
    if i == 1, 
      Xh{P + 1} = phi * Xh{1};
      nc = size(Xh{1}, 2); 
    end
  end
  if i > 1 
    ys = y(i - 1:P:end, :)'; 
    ac = [Xh{i}; ys(:, 1:nc)] / Xh{i - 1}; 
    a(:, :, i - 1) = ac(1:n, :);  
    c(:, :, i - 1) = ac(1 + n:end, :); 
  end
end
sysh = struct('a', a, 'c', c); 
xhini = Xh{1}(:, 1);
