function [y, x] = pltv_sim(sys, T, x0)
n = size(sys.a, 1); 
P = size(sys.a, 3); 
x(:, 1) = x0; y = [];
for t = 1:T
  tp =  mod(t - 1, P) + 1;
  y = [y sys.c(:, :, tp) * x(:, end)];
  x = [x sys.a(:, :, tp) * x(:, end)];
end  
y = y'; x(:, end) = [];
